> For the complete documentation index, see [llms.txt](https://docs.lukkit.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.lukkit.net/globals/global-variables/utilities.md).

# Utilities

Represented by `util`.

* **`util.getTableFromList(list: java.util.Collection | java.util.stream.Stream)` : table**

  Convert from a stream or collection in Java to a table in Lua.
* **`util.getTableFromArray(array: array)` : table**

  Convert from a array in Java to a table in Lua.
* **`util.getTableFromMap(map: java.util.Map)` : table**

  Convert from a map in Java to a table in Lua.
* **`util.getTableLength(table: table)` : int**

  Returns the amount of keys available in a table.
* **`util.runAsync(func: function, delay: int)`**

  Run an asynchronous function after a certain time in milliseconds.
* **`util.runDelayed(func: function, delay: int)`**

  Run a synchronous function after a certain time in milliseconds.
* **`util.getClass(class: string)` : java.lang.Class**

  Grab a class from Java using the package and name. (ie `java.io.File`)
* **`util.getSkullMeta(item: org.bukkit.inventory.ItemStack)` :** [**SkullWrapper**](https://github.com/artex-development/docs.lukkit.net/tree/9cfd55fd81df8d045428f2ce1c6a2bcf7bc208eb/globals/global-variables/Wrappers/README.md#Skull)

  Returns the SkullMeta from an ItemStack.
* **`util.getBannerMeta(item: org.bukkit.inventory.ItemStack)` :** [**BannerWrapper**](https://github.com/artex-development/docs.lukkit.net/tree/9cfd55fd81df8d045428f2ce1c6a2bcf7bc208eb/globals/global-variables/Wrappers/README.md#Banner)

  Returns the BennerMeta from an ItemStack.
* **`util.parseItemStack(item: org.bukkit.inventory.ItemStack)` :** [**ItemStackWrapper**](https://github.com/artex-development/docs.lukkit.net/tree/9cfd55fd81df8d045428f2ce1c6a2bcf7bc208eb/globals/global-variables/Wrappers/README.md#ItemStack)

  Convert the userdata from an ItemStack into a table.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.lukkit.net/globals/global-variables/utilities.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
